Subject: [Roll] projected route or not?

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 23 May 2019 08:21:18 +0000

Dear all

In case of an error in a P-route, the node that discovers an error notifies the root with a new ICMP "Error in Projected Route".
In the case of a storing mode PDAO, this is determined by the type of the route with the highest precedence in the routing able. But for non-storing, it is hard to fathom.

Possible solutions:

  *   it could be  implicit for any source route that does not originate from the root. But then, this may create a confusion in a future specification.
  *   update RFC 6550, RFC 6553 and RFC 8138 to add a flag in the RPI indicating projected route
  *   update RFC 6550, RFC 6554 and RFC 8138 to add a flag in the SRH indicating projected route
  *   encode that information implicitely in the instance ID by telling the nodes that a range of instance IDs are reserved for P DAO
  *   do not use "Error in Projected Route" to the root for non-storing P DAO. RPL has an ICMPv6 "error in Source Routing Header" message that is sent to the source of the packet. But that means that the packet goes to the source which then can notify the root. This is quite inefficient when the network is non storing.
  *   ?

What do you think?

Pascal

---

From: Rahul Arvind Jadhav <[email-masked]>
Date: Mon, 27 May 2019 01:19:32 +0000

Hi Pascal,

Just for my understanding, the points mentioned below are on how to handle the projected routes failure during installation using PDAO and handle the partially projected route cleanup and notification to the root. As I understand, the partial cleanup currently is left to the root (possibly by using PDAO(lifetime=0)) once the root is notified of the failure.
Post-installation, the projected path may fail and also needs cleanup and notification to root. Is this also part of this discussion?

The way I see it, there are overall 4 scenarios and 4 requirements for projected route cleanup:

Scenarios:

1.       Network is in Storing MOP, and the PDAO could be storing or non-storing

2.       Network is in non-storing MOP, and PDAO could be storing or non-storing

Requirements for projected route cleanup:

1.       During Installation of routes

a.       Notification to the root

b.      Cleanup of partially installed routes. (Root cleans up once notified of the failure?)

2.       Post-installation failure of routes

a.       Notification to the root

b.      Cleanup of projected routes

Network base MOP

PDAO type

During installation

Post Installation

Notification

Partial-PDAO Cleanup

Notification

Cleanup

Storing

Storing-PDAO

Non-storing PDAO

Non-storing

Storing-PDAO

Non-storing PDAO

I am not proposing my views on the solution here, but just trying to layout the full picture for error handling and trying to check if the understanding is ok.

Regards,
Rahul

From: Roll [mailto:[email-masked]] On Behalf Of Pascal Thubert (pthubert)
Sent: 23 May 2019 16:21
To: Routing Over Low power and Lossy networks <[email-masked]>
Cc: Li Zhao (liz3) <[email-masked]>
Subject: [Roll] projected route or not?

Dear all

In case of an error in a P-route, the node that discovers an error notifies the root with a new ICMP "Error in Projected Route".
In the case of a storing mode PDAO, this is determined by the type of the route with the highest precedence in the routing able.. But for non-storing, it is hard to fathom.

Possible solutions:
-          it could be  implicit for any source route that does not originate from the root. But then, this may create a confusion in a future specification.
-          update RFC 6550, RFC 6553 and RFC 8138 to add a flag in the RPI indicating projected route
-          update RFC 6550, RFC 6554 and RFC 8138 to add a flag in the SRH indicating projected route
-          encode that information implicitely in the instance ID by telling the nodes that a range of instance IDs are reserved for P DAO
-          do not use "Error in Projected Route" to the root for non-storing P DAO. RPL has an ICMPv6 "error in Source Routing Header" message that is sent to the source of the packet. But that means that the packet goes to the source which then can notify the root. This is quite inefficient when the network is non storing.
-          ?

What do you think?

Pascal

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 27 May 2019 08:59:56 +0000

Hello Rahul

?    Yes, during installation the draft says to use a negative DAO-Ack (e.g., status 11 if the problem is that the next hop is unreachable)  to the root and then the root does the cleanup as you indicate.

  *   That is the core of the discussion, when the route was installed but it is now broken.

Scenarios:

?    Yes, Rahul, we are in sync

     *   Notification to the root
     *   Cleanup of partially installed routes. (Root cleans up once notified of the failure?)

  1.  Post-installation failure of routes

     *   Notification to the root
     *   Cleanup of projected routes

Network base MOP
PDAO type
During installation
Post Installation
Notification
Partial-PDAO Cleanup
Notification
Cleanup
Storing
Storing-PDAO

Non-storing PDAO

Non-storing
Storing-PDAO

Non-storing PDAO

  *   This is all correct but so far the spec does not make a difference, always a DAO ack (e.g. status 11) if failure during install and an ICMP "Error in Projected Route" after that.

Do you see a need to be more specific?
I think the specific problems are more related to detection, e.g., determining that a packet is forwarded along a projected route when using non storing. This is why we're proposing to add a flag in the RPI.

Related is whether each P-route should be a different instance. Currently the draft allows the root to add routes to a main instance, e.g., global instance 0.

All the best,

Pascal

From: Roll [mailto:[email-masked]] On Behalf Of Pascal Thubert (pthubert)
Sent: 23 May 2019 16:21
To: Routing Over Low power and Lossy networks <[email-masked]<mailto:[email-masked]>>
Cc: Li Zhao (liz3) <[email-masked]<mailto:[email-masked]>>
Subject: [Roll] projected route or not?

Dear all

In case of an error in a P-route, the node that discovers an error notifies the root with a new ICMP "Error in Projected Route".
In the case of a storing mode PDAO, this is determined by the type of the route with the highest precedence in the routing able... But for non-storing, it is hard to fathom.

Possible solutions:

What do you think?

Pascal